/**
 * 
 */
package controllers.interceptors;

import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.juliac.Juliac;
import org.objectweb.fractal.juliac.desc.MembraneDesc;
import org.objectweb.fractal.juliac.proxy.AbstractInterceptorSourceCodeGenerator;
import org.objectweb.fractal.juliac.proxy.SimpleSourceCodeGeneratorMode;

/**
 * @author Michal Malohlava
 *
 */
public abstract class SoleilAbstractConnectorSourceCodeGenerator extends AbstractInterceptorSourceCodeGenerator {
	
	public SoleilAbstractConnectorSourceCodeGenerator() {
		super();
	}
	
	public SoleilAbstractConnectorSourceCodeGenerator(InterfaceType it, MembraneDesc membraneDesc, boolean mergeable, Juliac jc) {	    	        
	        super(it, membraneDesc, mergeable, jc );
	}	    
	
	public String getClassNameSuffix() {
		return "Soleil";
	}

	public boolean match() {
        
        // Skip control interfaces
        String itname = it.getFcItfName();
        if( itname.endsWith("-controller") || itname.equals("component") ) {
            return false;
        }
        
        // Analyze the mode
        SimpleSourceCodeGeneratorMode mode = getMode();
        boolean match = mode.match(it);
        return match;
    }	
	
	@Override
	public String[] getImplementedInterfaceNames() {
		System.out.println("==: Generating interceptor for interface " + it.getFcItfName() + " = " + it.getFcItfSignature() );
		return new String[] { it.getFcItfSignature() };
	}
	
	/**
	 * Strip package name and operations name from long class name.
	 * 
	 * @param longName
	 * @return
	 */
	public String getClassName(String longName) {
		String tmp = longName.substring(longName.lastIndexOf('.')+1, longName.length()) ;
		System.out.println(tmp);	
		return tmp.substring(0, tmp.lastIndexOf("Operations"));
	}
	
	abstract protected SimpleSourceCodeGeneratorMode getMode();	

}
